OGRE-Next: Ogre::StringInterface Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::StringInterface Class Reference
Core » General

Class defining the common interface which classes can use to present a reflection-style, self-defining parameter set to callers. More...

`#include <OgreStringInterface.h>`

Inheritance diagram for Ogre::StringInterface:
[legend]

## Public Member Functions
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary ()
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary () const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters () const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.

## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

## Detailed Description

Class defining the common interface which classes can use to present a reflection-style, self-defining parameter set to callers.

Remarks
  This class also holds a static map of class name to parameter dictionaries for each subclass to use. See ParamDictionary for details.
  In order to use this class, each subclass must call createParamDictionary in their constructors which will create a parameter dictionary for the class if it does not exist yet.

## Constructor & Destructor Documentation

## ◆ StringInterface()

Ogre::StringInterface::StringInterface | ( |  | ) |
| inline

Referenced by copyParametersTo().

## ◆ ~StringInterface()

virtual Ogre::StringInterface::~StringInterface | ( |  | ) |
| inlinevirtual

Virtual destructor, see Effective C++.

## Member Function Documentation

## ◆ cleanupDictionary()

void Ogre::StringInterface::cleanupDictionary | ( |  | ) |
| static

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

## ◆ copyParametersTo()

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const
| inlinevirtual

Method for copying this object's parameters to another object.

Remarks
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters

  dest | Pointer to object to have it's parameters set the same as this object.

References StringInterface(), getParamDictionary(), getParameter(), and setParameter().

## ◆ getParamDictionary() [1/2]

ParamDictionary * Ogre::StringInterface::getParamDictionary | ( |  | ) |
| inline

Retrieves the parameter dictionary for this class.

Remarks
  Only valid to call this after createParamDictionary.

Returns
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

Referenced by copyParametersTo(), and getParameter().

## ◆ getParamDictionary() [2/2]

const ParamDictionary * Ogre::StringInterface::getParamDictionary | ( |  | ) | const
| inline

## ◆ getParameter()

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const
| inlinevirtual

Generic parameter retrieval method.

Remarks
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters

  name | The name of the parameter to get

Returns
  String value of parameter, blank if not found

References getParamDictionary().

Referenced by copyParametersTo().

## ◆ getParameters()

const ParameterList & Ogre::StringInterface::getParameters | ( |  | ) | const

Retrieves a list of parameters valid for this object.

Returns
  A reference to a static list of ParameterDef objects.

## ◆ setParameter()

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value )
| virtual

Generic parameter setting method.

Remarks
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  name | The name of the parameter to set
  value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by copyParametersTo().

## ◆ setParameterList()

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) |
| virtual

Generic multiple parameter setting method.

Remarks
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  paramList | Name/value pair list

The documentation for this class was generated from the following file:

- OgreStringInterface.h